#define DPRINT g_print("Hello\n")

#define GCONFPREF_BASE "/apps"
#define GCONFPREF_SEPERATOR '/'
#define GCONFPREF_IMGDIR "pixmaps"
#define GCONFPREF_IMGDEF "unknown.png"

typedef struct
{
	//GConfClient variables
	GConfClient *gconf_client;
	GSList *gconf_change;
	char *gconf_key;
	//Important widgets and related objects
	GtkWidget *sidepane;
	GtkWidget *view;
	GtkWidget *view_top;
	GtkWidget *description;
} InternalData;

void initialize_app(GtkWidget *widget);
/*
This function will initialize things like the internal data structure and an initial view based on the sidebar.

	widget: Any widget.
*/

void finalize_app(GtkWidget *widget);

void refresh_sidepane(InternalData *data);
/* Updates the sidepane from gconf databse. This function also refreshs the view automatically.

	data: The universal data structure holding all the important values.
*/

void refresh_view(InternalData *data);
/*Use this function to update the view (currently a notebook) of the current gconf keys.

	view: The view which to update.
*/

InternalData *get_data_from_widget(GtkWidget *widget);
/* This function will easily let you get the internal data structure from any widgets

	widget: Any widget
	Returns: The internal data structure
*/

/*These functions are purly internal and should only be used in the functions above
*/

GtkWidget *internal_create_view(char *key, InternalData* data);

GtkWidget *internal_create_widgets_from_list (GSList * list);

int internal_compare_chars(gconstpointer a, gconstpointer b);
/*
Used in sorting, this function compares between two string.
This will probably be thrown out soon.

*/

GdkPixbuf* internal_get_image(char* data);
/*
This function returns the image relationg to the certian data. Implementation still a bit unsure.Currently this should already be the filename, not the gconf key.

	data: The data on which to get the image
	Returns: The widget containing the image
*/

char* internal_str_beautify(char* str);
/*
Returns a 'beautified' version of the string key str. Should be best used on GConf keys.
The returned string should be released.

	str: The string to beautify
	Returns: The beautified string
*/

GSList* internal_tidy_list(GSList *list);
/*
Returns a 'tidy'-ed up version of the list.

	list: The list to tidy
	Returns: The new list
*/
